use vulkan_sys::prelude::*;

pub struct VkLayerInstanceDispatchTable {
    // Manually add in GetPhysicalDeviceProcAddr entry
    GetPhysicalDeviceProcAddr: PFN_GetPhysicalDeviceProcAddr,

    // ---- Core 1_0 commands
    CreateInstance: PFN_vkCreateInstance,
    DestroyInstance: PFN_vkDestroyInstance,
    EnumeratePhysicalDevices: PFN_vkEnumeratePhysicalDevices,
    GetPhysicalDeviceFeatures: PFN_vkGetPhysicalDeviceFeatures,
    GetPhysicalDeviceFormatProperties: PFN_vkGetPhysicalDeviceFormatProperties,
    GetPhysicalDeviceImageFormatProperties: PFN_vkGetPhysicalDeviceImageFormatProperties,
    GetPhysicalDeviceProperties: PFN_vkGetPhysicalDeviceProperties,
    GetPhysicalDeviceQueueFamilyProperties: PFN_vkGetPhysicalDeviceQueueFamilyProperties,
    GetPhysicalDeviceMemoryProperties: PFN_vkGetPhysicalDeviceMemoryProperties,
    GetInstanceProcAddr: PFN_vkGetInstanceProcAddr,
    CreateDevice: PFN_vkCreateDevice,
    EnumerateInstanceExtensionProperties: PFN_vkEnumerateInstanceExtensionProperties,
    EnumerateDeviceExtensionProperties: PFN_vkEnumerateDeviceExtensionProperties,
    EnumerateInstanceLayerProperties: PFN_vkEnumerateInstanceLayerProperties,
    EnumerateDeviceLayerProperties: PFN_vkEnumerateDeviceLayerProperties,
    GetPhysicalDeviceSparseImageFormatProperties:
        PFN_vkGetPhysicalDeviceSparseImageFormatProperties,

    // ---- Core 1_1 commands
    EnumerateInstanceVersion: PFN_vkEnumerateInstanceVersion,
    EnumeratePhysicalDeviceGroups: PFN_vkEnumeratePhysicalDeviceGroups,
    GetPhysicalDeviceFeatures2: PFN_vkGetPhysicalDeviceFeatures2,
    GetPhysicalDeviceProperties2: PFN_vkGetPhysicalDeviceProperties2,
    GetPhysicalDeviceFormatProperties2: PFN_vkGetPhysicalDeviceFormatProperties2,
    GetPhysicalDeviceImageFormatProperties2: PFN_vkGetPhysicalDeviceImageFormatProperties2,
    GetPhysicalDeviceQueueFamilyProperties2: PFN_vkGetPhysicalDeviceQueueFamilyProperties2,
    GetPhysicalDeviceMemoryProperties2: PFN_vkGetPhysicalDeviceMemoryProperties2,
    GetPhysicalDeviceSparseImageFormatProperties2:
        PFN_vkGetPhysicalDeviceSparseImageFormatProperties2,
    GetPhysicalDeviceExternalBufferProperties: PFN_vkGetPhysicalDeviceExternalBufferProperties,
    GetPhysicalDeviceExternalFenceProperties: PFN_vkGetPhysicalDeviceExternalFenceProperties,
    GetPhysicalDeviceExternalSemaphoreProperties:
        PFN_vkGetPhysicalDeviceExternalSemaphoreProperties,

    // ---- Core 1_3 commands
    GetPhysicalDeviceToolProperties: PFN_vkGetPhysicalDeviceToolProperties,

    // ---- VK_KHR_surface extension commands
    DestroySurfaceKHR: PFN_vkDestroySurfaceKHR,
    GetPhysicalDeviceSurfaceSupportKHR: PFN_vkGetPhysicalDeviceSurfaceSupportKHR,
    GetPhysicalDeviceSurfaceCapabilitiesKHR: PFN_vkGetPhysicalDeviceSurfaceCapabilitiesKHR,
    GetPhysicalDeviceSurfaceFormatsKHR: PFN_vkGetPhysicalDeviceSurfaceFormatsKHR,
    GetPhysicalDeviceSurfacePresentModesKHR: PFN_vkGetPhysicalDeviceSurfacePresentModesKHR,

    // ---- VK_KHR_swapchain extension commands
    GetPhysicalDevicePresentRectanglesKHR: PFN_vkGetPhysicalDevicePresentRectanglesKHR,

    // ---- VK_KHR_display extension commands
    GetPhysicalDeviceDisplayPropertiesKHR: PFN_vkGetPhysicalDeviceDisplayPropertiesKHR,
    GetPhysicalDeviceDisplayPlanePropertiesKHR: PFN_vkGetPhysicalDeviceDisplayPlanePropertiesKHR,
    GetDisplayPlaneSupportedDisplaysKHR: PFN_vkGetDisplayPlaneSupportedDisplaysKHR,
    GetDisplayModePropertiesKHR: PFN_vkGetDisplayModePropertiesKHR,
    CreateDisplayModeKHR: PFN_vkCreateDisplayModeKHR,
    GetDisplayPlaneCapabilitiesKHR: PFN_vkGetDisplayPlaneCapabilitiesKHR,
    CreateDisplayPlaneSurfaceKHR: PFN_vkCreateDisplayPlaneSurfaceKHR,

    // ---- VK_KHR_get_physical_device_properties2 extension commands
    GetPhysicalDeviceFeatures2KHR: PFN_vkGetPhysicalDeviceFeatures2KHR,
    GetPhysicalDeviceProperties2KHR: PFN_vkGetPhysicalDeviceProperties2KHR,
    GetPhysicalDeviceFormatProperties2KHR: PFN_vkGetPhysicalDeviceFormatProperties2KHR,
    GetPhysicalDeviceImageFormatProperties2KHR: PFN_vkGetPhysicalDeviceImageFormatProperties2KHR,
    GetPhysicalDeviceQueueFamilyProperties2KHR: PFN_vkGetPhysicalDeviceQueueFamilyProperties2KHR,
    GetPhysicalDeviceMemoryProperties2KHR: PFN_vkGetPhysicalDeviceMemoryProperties2KHR,
    GetPhysicalDeviceSparseImageFormatProperties2KHR:
        PFN_vkGetPhysicalDeviceSparseImageFormatProperties2KHR,

    // ---- VK_KHR_device_group_creation extension commands
    EnumeratePhysicalDeviceGroupsKHR: PFN_vkEnumeratePhysicalDeviceGroupsKHR,

    // ---- VK_KHR_external_memory_capabilities extension commands
    GetPhysicalDeviceExternalBufferPropertiesKHR:
        PFN_vkGetPhysicalDeviceExternalBufferPropertiesKHR,

    // ---- VK_KHR_external_semaphore_capabilities extension commands
    GetPhysicalDeviceExternalSemaphorePropertiesKHR:
        PFN_vkGetPhysicalDeviceExternalSemaphorePropertiesKHR,

    // ---- VK_KHR_external_fence_capabilities extension commands
    GetPhysicalDeviceExternalFencePropertiesKHR: PFN_vkGetPhysicalDeviceExternalFencePropertiesKHR,

    // ---- VK_KHR_performance_query extension commands
    EnumeratePhysicalDeviceQueueFamilyPerformanceQueryCountersKHR:
        PFN_vkEnumeratePhysicalDeviceQueueFamilyPerformanceQueryCountersKHR,
    GetPhysicalDeviceQueueFamilyPerformanceQueryPassesKHR:
        PFN_vkGetPhysicalDeviceQueueFamilyPerformanceQueryPassesKHR,

    // ---- VK_KHR_get_surface_capabilities2 extension commands
    GetPhysicalDeviceSurfaceCapabilities2KHR: PFN_vkGetPhysicalDeviceSurfaceCapabilities2KHR,
    GetPhysicalDeviceSurfaceFormats2KHR: PFN_vkGetPhysicalDeviceSurfaceFormats2KHR,

    // ---- VK_KHR_get_display_properties2 extension commands
    GetPhysicalDeviceDisplayProperties2KHR: PFN_vkGetPhysicalDeviceDisplayProperties2KHR,
    GetPhysicalDeviceDisplayPlaneProperties2KHR: PFN_vkGetPhysicalDeviceDisplayPlaneProperties2KHR,
    GetDisplayModeProperties2KHR: PFN_vkGetDisplayModeProperties2KHR,
    GetDisplayPlaneCapabilities2KHR: PFN_vkGetDisplayPlaneCapabilities2KHR,

    // ---- VK_KHR_fragment_shading_rate extension commands
    GetPhysicalDeviceFragmentShadingRatesKHR: PFN_vkGetPhysicalDeviceFragmentShadingRatesKHR,

    // ---- VK_EXT_debug_report extension commands
    CreateDebugReportCallbackEXT: PFN_vkCreateDebugReportCallbackEXT,
    DestroyDebugReportCallbackEXT: PFN_vkDestroyDebugReportCallbackEXT,
    DebugReportMessageEXT: PFN_vkDebugReportMessageEXT,

    // ---- VK_NV_external_memory_capabilities extension commands
    GetPhysicalDeviceExternalImageFormatPropertiesNV:
        PFN_vkGetPhysicalDeviceExternalImageFormatPropertiesNV,

    // ---- VK_EXT_display_surface_counter extension commands
    GetPhysicalDeviceSurfaceCapabilities2EXT: PFN_vkGetPhysicalDeviceSurfaceCapabilities2EXT,

    // ---- VK_EXT_debug_utils extension commands
    CreateDebugUtilsMessengerEXT: PFN_vkCreateDebugUtilsMessengerEXT,
    DestroyDebugUtilsMessengerEXT: PFN_vkDestroyDebugUtilsMessengerEXT,
    SubmitDebugUtilsMessageEXT: PFN_vkSubmitDebugUtilsMessageEXT,

    // ---- VK_EXT_sample_locations extension commands
    GetPhysicalDeviceMultisamplePropertiesEXT: PFN_vkGetPhysicalDeviceMultisamplePropertiesEXT,

    // ---- VK_EXT_calibrated_timestamps extension commands
    GetPhysicalDeviceCalibrateableTimeDomainsEXT:
        PFN_vkGetPhysicalDeviceCalibrateableTimeDomainsEXT,

    // ---- VK_EXT_tooling_info extension commands
    GetPhysicalDeviceToolPropertiesEXT: PFN_vkGetPhysicalDeviceToolPropertiesEXT,

    // ---- VK_NV_cooperative_matrix extension commands
    GetPhysicalDeviceCooperativeMatrixPropertiesNV:
        PFN_vkGetPhysicalDeviceCooperativeMatrixPropertiesNV,

    // ---- VK_NV_coverage_reduction_mode extension commands
    GetPhysicalDeviceSupportedFramebufferMixedSamplesCombinationsNV:
        PFN_vkGetPhysicalDeviceSupportedFramebufferMixedSamplesCombinationsNV,

    // ---- VK_EXT_headless_surface extension commands
    CreateHeadlessSurfaceEXT: PFN_vkCreateHeadlessSurfaceEXT,

    // ---- VK_EXT_acquire_drm_display extension commands
    AcquireDrmDisplayEXT: PFN_vkAcquireDrmDisplayEXT,
    GetDrmDisplayEXT: PFN_vkGetDrmDisplayEXT,

    // ---- VK_NV_optical_flow extension commands
    GetPhysicalDeviceOpticalFlowImageFormatsNV: PFN_vkGetPhysicalDeviceOpticalFlowImageFormatsNV,
}
